//! ```cargo
//! [package]
//! edition = "2018"
//! [dependencies]
//! anyhow = "*"
//! ```

#![allow(clippy::collapsible_else_if)]
#![allow(clippy::double_parens)] // https://github.com/adsharma/py2many/issues/17
#![allow(clippy::map_identity)]
#![allow(clippy::needless_return)]
#![allow(clippy::print_literal)]
#![allow(clippy::ptr_arg)]
#![allow(clippy::redundant_static_lifetimes)] // https://github.com/adsharma/py2many/issues/266
#![allow(clippy::unnecessary_cast)]
#![allow(clippy::upper_case_acronyms)]
#![allow(clippy::useless_vec)]
#![allow(non_camel_case_types)]
#![allow(non_snake_case)]
#![allow(non_upper_case_globals)]
#![allow(unused_imports)]
#![allow(unused_mut)]
#![allow(unused_parens)]

extern crate anyhow;
use anyhow::Result;
use std::collections;
use std::collections::HashMap;

pub fn nested_containers() -> bool {
    let CODES: &HashMap<&str, Vec<i32>> = &[("KEY", vec![1, 3])]
        .iter()
        .cloned()
        .collect::<HashMap<_, _>>();
    return CODES[&"KEY"].iter().any(|&x| x == 1);
}

pub fn main() -> Result<()> {
    if nested_containers() {
        println!("{}", "OK");
    }
    Ok(())
}
